﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using StructureMap;
using StructureMap.Configuration.DSL;
using SharpTrack.Application.Services;
using SharpTrack.Data.DataAccess.MsSql;
using System.Web.Mvc; 

namespace SharpTrack.Application.Web {
    
    public class Bootstrapper {
        public static void Configure() {
            StructureMapConfiguration.AddRegistry(new SharpTrackRegistry());
        }
    }

   
    public class SharpTrackRegistry : Registry {

        protected override void configure() {

            ForRequestedType<IProjectsService>()
                .TheDefaultIsConcreteType<ProjectsService>();

            ForRequestedType<Data.DataAccess.IProjectsRepository>()
                .TheDefaultIsConcreteType<SqlProjectsRepository>();
        }
    }
}
