﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SharpTrack.Data.Model
{
    /// <summary>
    /// Класс представляет собой сущность "Проект"
    /// </summary>
    public class Project : IEntity
    {
        public Project(Guid projectId, string name) 
            : this(new ProjectId(projectId, name)) {

        }

        public Project(ProjectId pId) {
            ProjectId = pId;
        }

        public ProjectId ProjectId { get; set; }

        public string Description {
            get;
            set;
        }    

        #region IEntity Members

        public DateTime CreatedOn
        {
            get;
            set;
        }

        public DateTime ModifiedOn {
            get;
            set;
        }

        public SystemUserId CreatedBy
        {
            get;
            set;
        }

        public SystemUserId ModifiedBy
        {
            get;
            set;
        }

        #endregion

        public SystemUserId Owner
        {
            get;
            set;
        }
    }
}
